QGIS Application - Bug report #17305
Labeling using setCustomProperty()
2017-10-18 09:08 PM - Markus Woehling

Status: Closed
Priority: High
Assignee:

Category: Labelling

Affected QGIS version:2.18.13
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: Yes
Easy fix?: No
Resolution: invalid

Copied to github as #: 25203

Description

It's not possible anymore to configure labeling (for QgsVectorLayer) using setCustomProperty().
It will be a breaking change in QGIS 3.0, but it's not working in 2.18.13 right now.

So | think it's a bug - especially because 2.18.13 isa LTR.

History

#1 - 2017-10-19 11:03 AM - Giovanni Manghi
- Status changed from Open to Feedback

did it worked in previous qgis releases?

#2 - 2017-10-19 11:13 AM - Markus Woehling

Yes, it did work up to version 2.14 (but | did not check 2.16).

#3 - 2017-10-19 11:18 AM - Giovanni Manghi

- Priority changed from Normal to High

- Status changed from Feedback to Open

#4 - 2017-10-19 05:48 PM - Regis Haubourg

Can you test EasyCustomLabeling plugin?

It uses setCustomProperty() a lot and in my experience, it works on 2.18.13.

#5 - 2017-10-19 11:26 PM - Markus Woehling

EasyCustomLabeling is working on 2.18.13, right.
| found out that setCustomProperty() is working fine in the python console.

So my problem is not setCustomProperty() itself, but something with the QVariant and/or QLatin1String type.

Labeling seems to be correctly configured when | check it in the python console:

layer = iface.activeLayer()

layer.customProperty("labeling")
pal'
layer.customProperty("labeling/enabled")

true’

But when | look at the types the result is this:

| layer.customProperty("labeling”).__class__

<class 'future.types.newstr.newstr'>

| layer.customProperty("labeling/enabled").__class__

<class 'future.types.newstr.newstr'>

This code does NOT make labeling work:

But this code does:

And this code also - at least in the python console:

layer.setCustomProperty("labeling", layer.customProperty("labeling"))

layer.setCustomProperty("labeling/enabled", layer.customProperty("labeling/enabled"))

layer.setCustomProperty("labeling", 'pal’)

layer.setCustomProperty("labeling/enabled", 'true’)

layer.setCustomProperty("labeling", str(layer.customProperty("labeling”)))

layer.setCustomProperty("labeling/enabled", str(layer.customProperty("labeling/enabled")))

| am not able to workaround this issue, because in my plugin the str() function always return a "newstr".

Do you have any hints how | could workaround this issue?

Maybe this line of code is the cause of this problem (QgsVectorLayer.cs, line 4546 in master):

if ( customProperty( QStringLiteral( "labeling" ) ).toString() == QLatin1String( "pal") )

#6 - 2017-10-20 09:46 AM - Giovanni Manghi
- Status changed from Open to Feedback

Markus Woehling wrote:

EasyCustomLabeling is working on 2.18.13, right.
I found out that setCustomProperty() is working fine in the python console.
So my problem is not setCustomProperty() itself, but something with the QVariant and/or QLatin1String type.

so maybe is better to close this and file a different one? or maybe edit the title and description of this one. Thanks.

#7 - 2017-10-20 10:23 AM - Markus Woehling

| wanted to change the title of this issue to:

Problem with conversion of strings, e.g. when labeling using setCustomProperty()

But I'm not able to do it... so I'll created a new issue.

#8 - 2017-10-20 10:47 AM - Giovanni Manghi
- Resolution set to invalid

- Status changed from Feedback to Closed

Closed in favor of #17307
